unit uforzamientos;


interface

uses
  Classes, SysUtils, xmatdefs, ufichasLPD, ucosa,
  ufechas;



type

TFichaForzamientos = class(TFichaLPD)
 public
   activar_forzamiento: boolean;
   P: TDAofNReal;
   constructor Create(capa: integer; fecha: TFecha; periodicidad: TPeriodicidad;
     activar_forzamiento: boolean; P: TDAOfNReal);
   procedure Free; override;
   constructor Create_ReadFromText(f: TArchiTexto); override;
   procedure WriteToText(f: TArchiTexto); override;
   function InfoAd_: string; override;
   procedure generarLineaResumen(var archi: TextFile); override;
 end;


procedure AlInicio;
procedure AlFinal;

resourcestring
  rsForzamientoInactivo = 'Inactivo';
  rsForzamientoActivo = 'Activo';


implementation

//-------------------------
//Metodos de TFichaForzamientos
//=========================
constructor TFichaForzamientos.Create(capa: integer; fecha: TFecha; periodicidad: TPeriodicidad;
     activar_forzamiento: boolean; P: TDAOfNReal);
begin
  inherited Create(capa, fecha, periodicidad);
  self.activar_forzamiento:= activar_forzamiento;
  self.P:= P;
end;

procedure TFichaForzamientos.Free;
begin
  setlength(P, 0);
  inherited Free;
end;


constructor TFichaForzamientos.Create_ReadFromText(f: TArchiTexto);
begin
  inherited Create_ReadFromText(f);
  f.IniciarLecturaRetrasada;
  f.rd('activo', activar_forzamiento );
  f.rd('P', P);
  f.EjecutarLectura;
end;

procedure TFichaForzamientos.WriteToText(f: TArchiTexto);
begin
  inherited WriteToText(f);
  f.wr('activo', activar_forzamiento );
  f.wr('P', P);
end;

function TFichaForzamientos.infoAd_: string;
begin
  if activar_forzamiento then
   Result := inherited infoAd_ +rsForzamientoActivo+', '+ DAOfNRealToStr_(self.P, 12, 2, ';')
  else
   Result := inherited infoAd_ +rsForzamientoInactivo+', '+ DAOfNRealToStr_(self.P, 12, 2, ';')
end;

procedure TFichaForzamientos.generarLineaResumen(var archi: TextFile);
begin
  Write(archi, infoAd_, #9);  //NUnidades
end;


procedure AlInicio;
begin
  registrarClaseDeCosa(TFichaForzamientos.ClassName, TFichaForzamientos);
end;

procedure AlFinal;
begin
end;


end.

